#
# aut.pm - mkprimer module for the aut explorer, with the generic primer
# will be ``required'' by the mkprimer program
#
# $Id: aut.pm,v 1.1.2.2 2006/02/15 11:14:48 belinfan Exp $
# <Axel.Belinfante@cs.utwente.nl>, 1999
#
#
# ======================================
package aut;

%suffix = (
			".aut"     =>   "AUT",
	     );

%lang = (
	"AUT" =>
	 sub  {
		my($specfile, $target, $prefix, $libdir,
		   $specpath, $specname, $specsuffix, $exesuffix, $paramsref) = @_;
		my($flag);
		my(%params) = %$paramsref;
		if ($params{config} ne "") {
			if ($params{config} !~ /^\//) {
				$params{config} = '\\$d/'.$params{config};
			}
			$flag = '-f '.$params{config};
		}
		if ($specfile !~ /^\//) {
			$specfile = '\\$d/'.$specfile;
		}
		my(@cmds) = (
			"echo '#!/bin/sh' > $target",
			"echo 'd=`echo \$0|sed '\"'\"'s/[^\/]*\$//'\"'\"' `' >> $target",
			"echo exec primer $flag \\\"\\\$@\\\" autexp $specfile >> $target",
			"chmod 755 $target",
		          );
		::Exec(@cmds);
	},
);

::Register(\%lang, \%suffix);

1;
