#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

int handle_cmd(char *cmd);
int prep_c_event(char *cmd);
int c_event(char *event, char *predicates);
int c_getconfig();
int c_quit();
int choosefromdomain(char *domain);

int main(int argc, char *argv[]) {
	char *buffer;
	char *fgets_ret;
	
	int i,n;
	
	
	buffer = malloc(2048);
	
	srand(3);
	
//	for ( i = 0; i < 20; i++ ) {
//		n = choosefromdomain("{ 1..10, 21..30, 45 }");
//		printf("%d\n", n);
//	}
//	
//	// C_EVENT event=from_rec ! var_int$1 ! var_int$2	predicates=var_int$1 in {1..10, 21..30, 45 }; var_int$2 in {50..60, 70..80 }
//	n = c_event(strdup("from_rec ! var_int$1 ! var_int$2"), strdup("var_int$1 in {1..10, 21..30, 45 }; var_int$2 in {50..60, 70..80 }"));
//	
//	return 0;
	
	do {
		fgets_ret = fgets(buffer, 2048, stdin);
	} while ( fgets_ret && handle_cmd(buffer) );


	return 0;
}


int handle_cmd(char *cmd) {
	int keepgoing = 1;
	
	if ( (strncmp(cmd, "C_EVENT", 7) == 0)) {
		keepgoing = prep_c_event(cmd);
	} else if ( (strncmp(cmd, "C_GETCONFIG ", 11) == 0) && isspace(cmd[11]) ) {
		keepgoing = c_getconfig();
	} else if ( (strncmp(cmd, "C_QUIT ", 6) == 0) && isspace(cmd[6]) ) {
		keepgoing = c_quit();
	} else {
		fprintf(stdout, "A_ERROR UnknownCommand\n");
		keepgoing = 1;
	}
	
	return keepgoing;
}

int c_getconfig() {
	fprintf(stdout, "A_GETCONFIG\n");
	return 1;
}

int c_quit() {
	fprintf(stdout, "A_QUIT\n");
	return 0;
}


int prep_c_event(char *cmd) {
	char *event = NULL;
	char *predicates = NULL;
	char *next = NULL;
	
	cmd += 7; // Skip past "C_EVENT" at front
	
	while ( *cmd == ' ' || *cmd == '\t' ) {
		cmd++;
	}

	while ( *cmd != '\n' && *cmd != '\0') {
		if (strncmp("event=", cmd, 6) == 0 ) {
			cmd += 6;
			event = strtok(cmd, "\t\n");
			if (event != 0) {
				// Skip past current token
				cmd += strlen(event) + 1;
			}
		} else if (strncmp("predicates=", cmd, 11) == 0 ) {
			cmd += 11;
			predicates = strtok(cmd, "\t\n");
			if (predicates != 0) {
				// Skip past current token
				cmd += strlen(predicates) + 1;
			}
		} else {
			// Illegal argument
			fprintf(stdout, "A_WARNING UnknownValue\n");
			next = strtok(cmd, "\t\n");
			if (next != 0) {
				cmd += strlen(next) + 1;
			}
		}
		// Skip past (optional) tab(s)
		while ( *cmd == '\t' ) {
			cmd++;
		}
			
	}
	
	if ( predicates == NULL ) {
		fprintf(stdout, "A_ERROR ArgumentMissing\n");
		return 1;
	} else {
		fprintf(stderr, "A_DEBUG Calling C_EVENT with event='%s' (%p) and predicates='%s' (%p)\n",
			 (event == 0) ? "<nil>" : event,
			 event,
			 (predicates == 0) ? "<nil>" : predicates,
			 predicates);
		return c_event(event, predicates);
	}
}

int c_event(char *event, char *predicates) {
	char *cur;
	char *next;
	
	char *pred_arr[64];
	int pred_value[64];
	int pred_index = 0;
	
	//printf("C_EVENT with event='%s' and predicates='%s'\n", event, predicates); 
	
	// For each identifier in the list of predicates, we need to replace it with a random value from its interval
	
	// The 'list of predicates' consists of 'predicates' sepparated by a ';' (possibly surrounded by whitespace)
	// Each predicate consists of: an identifier, the token 'in' and a domain
	// Each domain consists of: an opening brace '{', a list of ranges (sepparated by ',') and a closing brace '}'.
	
	
	// Tokenize predicates for the array
	for(pred_index = 0 ; pred_index < 64 ; pred_index++) {
		if ( pred_index == 0 ) {
			pred_arr[pred_index] = strtok(predicates, ";");
		} else {
			pred_arr[pred_index] = strtok(NULL, ";");
			
		}
		
		
		if ( pred_arr[pred_index] == NULL ) {
			break;
		} else {
			while ( *pred_arr[pred_index] == ' ' )
				pred_arr[pred_index]++;
			// TODO No time for error checking, to see if '{' is present.
			// Stores a random value for the predicate in the indicated domain
			pred_value[pred_index] = choosefromdomain(strstr(pred_arr[pred_index], "{"));	
		}
	}
	
	// Debug print
//	for( pred_index = 0; pred_arr[pred_index] != NULL; pred_index++ ) {
//		printf("%s\n", pred_arr[pred_index]);
//	}
//	fflush(stdout);
	

	// If there is no event, we don't care.
	if ( event == NULL ) {
		fprintf(stdout, "A_EVENT predicates=");
		for (pred_index = 0; pred_index < 64 && pred_arr[pred_index] != NULL; pred_index++) {
			// Print the name of the var
			int tok_length = 0;
			char tmp[32];

			while ( pred_arr[pred_index][tok_length] != ' ' && 
				pred_arr[pred_index][tok_length] != '\0' && 
				pred_arr[pred_index][tok_length] != '!' ) {
				tok_length++;
			}

			
			sprintf(tmp, "%%.%ds", tok_length);
			fprintf(stdout, tmp, pred_arr[pred_index]);
			
			// Print the value
			fprintf(stdout, "=%d", pred_value[pred_index]);
			if (pred_arr[pred_index+1] != NULL ) {
				fprintf(stdout, ";");
			} else {
				fprintf(stdout, "\n");
				fflush(stdout);
				break;
			}
		}	
	} else {

		fprintf(stdout, "A_EVENT event=");
		cur = event;
		while ( (next = strstr(cur, "var")) != NULL ) {
			// 'cur' points to the place after the last token
			// 'next' points to the first occurance of "var" after 'cur'
			int tok_length = 0;
			
			// Determine length of normalized name
			while ( next[tok_length] != ' ' && next[tok_length] != '\0' && next[tok_length] != '!' ) {
				tok_length++;
			}
			
			// Look for normalized name in the list of predicates
			for ( pred_index = 0; pred_arr[pred_index] != NULL; pred_index++) {
				if ( strncmp(next, pred_arr[pred_index], tok_length) == 0 ) {
					break;
				}
			}
			
			// Als we de huidige 'var' vinden in de lijst van predicaten
			if ( pred_arr[pred_index] != NULL ) {
				// print hetgene van cur tot aan 'var'
				*next = '\0';
				fprintf(stdout, "%s", cur);
				// print een random waarde voor var
				fprintf(stdout, "%d", pred_value[pred_index]);
				// verplaats cur tot achter 'var'
				cur = next + tok_length;
			} else {
			// Anders
				char saved_char;
				// print hetgene van cur t/m de huidige 'var'
				next = next + 3; // Skip 'var'
				saved_char = *next; // Save char before overwriting
				*next = '\0';
				fprintf(stdout, "%s", cur);
				*next = saved_char;
				// verplaats cur tot achter 'var'
				cur = next;
			}
		}
		// Print het stuk na de laatste 'var'
		fprintf(stdout, "%s\tpredicates=\n", cur);
	
	}
	
	fflush(stdout);
	
	return 1;
}

typedef struct range {
	signed long lb;
	signed long ub;
	struct range *next;
} Range;

int choosefromdomain(char *dom) {
	// Size of domain
	unsigned long size = 0;
	signed long value;
	
	Range *firstRange = NULL;
	Range *lastRange = NULL;
	
	Range *r;
	Range *nextR;
	
	char *domain = dom;
	
	// Skip leading '{'
	domain++;
	
	while ( *domain == ' ' )
		domain++;

	// Parse the range
	while ( *domain != '}' && domain != '\0' ) {
		// Append a new Range at the end
		if ( firstRange == NULL ) {
			firstRange = lastRange = calloc(1, sizeof(Range));
		} else {
			lastRange->next = calloc(1, sizeof(Range));
			lastRange = lastRange->next;
		}
		
		lastRange->lb = atoi(domain);
		if (*domain == '-')
			domain++;
		while ( isdigit(*domain) )
			domain++;

		while ( *domain == ' ' )
			domain++;

		
		// Only a single value
		if ( *domain == ',' || *domain == '}' ) {
			lastRange->ub = lastRange->lb;
		} else if ( domain[0] == '.' && domain[1] == '.' ) {
			// Second value
			domain += 2;
			
			// TODO Should check if UB >= LB

			lastRange->ub = atoi(domain);
			if (*domain == '-')
				domain++;
			while ( isdigit(*domain) )
				domain++;
			
		} else {
			// Should not happen!
			fprintf(stderr, "A_WARNING InternalError in choosefromdomain(), when choosing from %s\n", dom);
			return 1;
		}
		
		size += (lastRange->ub - lastRange->lb) + 1;
		
		while ( *domain == ' ' || *domain == ',')
			domain++;

			
	}
	// Done with parsing.
	// Now select a random value, inside the domain.
	
	// First select a value inside the 'size'. Then we'll adjust the value for the ranges
	value = rand();
	//printf("rand was %d\n", value);
	value = value % size;
	//printf("value was %d\n", value);
	
	for ( r = firstRange; r != NULL && (value + r->lb > r->ub); r = r->next) {
		value -= r->ub - r->lb + 1;
	}
	
	// Prepare return value
	if ( r == NULL ) {
		fprintf(stderr, "A_ERROR InternalError in choosefromdomain()\n");
		value = 0;
	} else {
		value = value + r->lb;
	}
		
	// Free allocated Ranges
	for ( r = firstRange; r != NULL; r = nextR ) {
		nextR = r->next;
		free(r);
	}
		
	return value;
}

/* EOF */
