proc ExwinFtocMsgBoundary {frame name win errorline} {
    global exwin
    set exwin($win,errorline) $errorline
	Debug_FnArgs "ExwinFtocMsgBoundary" $win $frame
	set f [frame $frame.$name]
    pack $f -side top -fill x
    set c [canvas $f.boundary -width 16 -height 15]
    # pack $frame.boundary -side right -fill y
    # pack $frame.boundary -side top -fill y
    pack $c -side right -fill x
    # set fg [option get . c_foreground {}]
    # set fg [$frame cget -foreground]
    set fg [. cget -highlightcolor]
    set it [$c create poly 8 2  15 9  8 16  1 9 -fill $fg]
    $c bind $it <ButtonPress-1> "ExwinFtocMsgScroll $win %W %x %y"
    $c bind $it <B1-Motion> "ExwinFtocMsgMove $win %W %x %y"
    $c bind $it <ButtonRelease-1> "ExwinFtocMsgStop $win %W %x %y"
}
proc ExwinTopY {w y} {
    # Find Y hit relative to toplevel window
    set top [winfo toplevel $w]
    while {[string compare $w $top] != 0} {
	incr y [winfo y $w]
	set w [winfo parent $w]
    }
    return $y
}
proc ExwinFtocMsgScroll {win canvas x y} {
    global exwin
    set top [winfo toplevel $canvas]
    if {$top == "."} {
	set exwin(boundary) .boundary
    } else {
	set exwin(boundary) $top.boundary
    }
    # set bg [option get . c_foreground {}]
    # set bg [. cget -foreground]
    set bg [. cget -highlightcolor]
    frame $exwin(boundary) -width [winfo width $top] -height 2 -bg $bg
    place $exwin(boundary) -y [ExwinTopY $canvas $y] -x 0 -anchor w
    set_label $exwin($win,errorline) "Adjust subwindow boundaries"

    # Record Y coordinate of bottom of each subwindow
    set exwin(y,$win) [ExwinTopY $win [winfo height $win]]
    set exwin(y,start) [ExwinTopY $canvas $y]
}
proc ExwinFtocMsgMove {win canvas x y} {
    global exwin
    set ytop [ExwinTopY $canvas $y]
    place $exwin(boundary) -y $ytop
}
proc ExwinFtocMsgStop {win canvas x y} {
    global exwin
    catch {destroy $exwin(boundary)}
    # Deduce height of text line in FTOC
    if ![info exists exwin(ftocLineHeight)] {
	if [catch {ExwinLineHeight $win} x] {
	    set_label $exwin($win,errorline) "Can only resize if the window contains text"
	    return
	}
	set exwin(ftocLineHeight) $x
    }
    set exwin(ftextLines) [$win cget -height]
	set dy [expr [ExwinTopY $canvas $y] - $exwin(y,$win)]
	set dsy [expr [ExwinTopY $canvas $y] - $exwin(y,start)]
	set chunk $exwin(ftocLineHeight)
    set dl [expr int(round($dy / double($chunk)))]
    set dsl [expr int(round($dsy / double($chunk)))]
    Debug_Msg ExwinFtocMsgStop "dy $dy dsy $dsy chunk $chunk y $exwin(ftextLines) dl $dl dsl $dsl"
    # set dl $dsl
    if {$dl != 0} {
	# The exwin(ftextLines) and fdisp(maxLines) are traced so
	# the display updates when they change.
	set x [expr $exwin(ftextLines) + $dl]
	if {$x <= 0} {set x 1}
	set exwin(ftextLines) $x
	set msg "updating window size: $exwin(ftextLines) lines"
    Debug_FnRes ExwinFtocMsgStop "$msg"
	set var exwin(ftextLines)
	# Let redisplay kick in
	after 100 "
	    set_label $exwin($win,errorline)  \"$msg...\"
	    $win configure -height $exwin(ftextLines)
	    set_label $exwin($win,errorline)  \"$msg...ok\"
	    after 1000 set_label $exwin($win,errorline)  \\\"\\\"
	"
    } else {
		set_label $exwin($win,errorline) ""
    }
}
proc ExwinLineHeight {w} {
    set i 0
    if {[scan [$w index @0,$i] %d top] != 1} {
	error ExwinLineHeight
    }
    set limit [winfo height $w]
    while {$i < $limit} {
	incr i
	scan [$w index @0,$i] %d next
	if {$next != $top} {
	    Debug_FnRes ExwinLineHeight "$w limit $limit i $i top $top next $next"
	    return $i
	}
    }
    error "Cannot handle empty windows"
}
