# =========================================================================
# $Id: utils.tcl,v 1.1.2.35 2006/01/24 21:42:37 belinfan Exp $
# =========================================================================

proc do_activate_or_cond_set {args} {
	global tester
	set w [lindex $args 0]
	set dummy [lindex $args 1]
	set cond_var_but [lindex $args 2]
	set cond [lindex $cond_var_but 0]
	set var [lindex $cond_var_but 1]
	set but [lindex $cond_var_but 2]
	set cond_w [WcFullNameToWidget . $cond]
	set but_w [WcFullNameToWidget . $but]
	if {[check_get $cond_w]} {
		wcExecCB $but_w activate
	} else {
		WcSetCondSensitive $w "" [list $var $but]
	}
}

proc do_activate {args} {
	global tester
	set w [lindex $args 0]
	set dummy [lindex $args 1]
	set but_emptylist [lindex $args 2]
	set but [lindex $but_emptylist 0]
	set but_w [WcFullNameToWidget . $but]
	# wcExecCB $but_w activate
	$but_w invoke
}

# =========================================================================
#
# utility routines, that are used in the callbacks
#

proc process_out_build_menu { line } {
	global tester
	if {[regexp "^input(\\(\[^()]*\\))?:\[ \t]*(\[^\r\n]+)\r*\$" $line match chan event ]} {
		if {[string compare $chan ""] != 0} {
			set menu_el "$chan $event"
		} else {
			set menu_el "$event"
		}
		$tester(list,inputs) insert end $menu_el
	} elseif {[regexp "^output(\\(\[^\(\)]*\\))?:\[ \t]*(\[^\r\n]+)\r*\$" $line match chan event ]} {
		if {[string compare $chan ""] != 0} {
			set menu_el "$chan $event"
		} else {
			set menu_el "$event"
		}
		if {[string compare $chan out] == 0} {
			$tester(list,outputs) insert end $menu_el
		} elseif {[string compare $chan in] == 0} {
			$tester(list,inputs) insert end $menu_el
		} else {
			# no channel info, use outputs
			$tester(list,outputs) insert end $menu_el
		}
	} elseif {[regexp "^(\[^\r\n]*)\r*\$" $line match msg ]} {
		messages_append "$msg\n"
	} else {
		puts stderr "internal error: process_out_build_menu cannot handle: $line"
	}
}

proc build_menu { cmd } {
	global tester
	listbox_clear $tester(list,inputs)
	listbox_clear $tester(list,outputs)
#	$tester(button,selectedinputs) configure -state disabled

	process_cmd $cmd process_out_build_menu
}

proc process_out_manual_stimulus_wait_for_prompt { line } {
	global tester
	if {[regexp "^(torx_ui_manual_stimulus_prompt\[ \t]*(\[^ \t\n\r]*)\[ \t]*)\r*\$" $line match msg prompt]} {
		messages_append $msg\n
		set tester(manualio,prompt) $prompt
	} elseif {[regexp "^(\[^\r\n]*)\r*\$" $line match msg} {
		messages_append $msg\n
		append tester(manualio,message) $msg\n
	} else {
		puts stderr "internal error: process_out_manual_stimulus_wait_for_prompt cannot handle: $line"
	}
}

proc process_out_manual_stimulus_wait_for_finalization { line } {
	global tester
	if {[regexp "^(torx_ui_manual_stimulus_finalization_end)\r*\$" $line match msg]} {
		messages_append $msg\n
		set tester(manualio,finalization) 1
	} elseif {[regexp "^(\[^\r\n]*)\r*\$" $line match msg} {
		messages_append $msg\n
		append tester(manualio,finalization) $msg\n
	} else {
		puts stderr "internal error: process_out_manual_stimulus_wait_for_prompt cannot handle: $line"
	}
}

proc process_out_manual_stimulus_wait_for_end { line } {
	global tester
	if {[regexp "^(torx_ui_manual_stimulus_end)\r*\$" $line match msg]} {
		messages_append $msg\n
		set tester(manualio,end) 1
	} elseif {[regexp "^(torx_ui_manual_stimulus_finalization_start)\r*\$" $line match msg} {
		messages_append $msg\n
		set tester(manualio,finalization) ""
		set handler [push_out_handler "" process_out_manual_stimulus_wait_for_finalization tester(manualio,finalization)]
		after 1 { tk_messageBox -icon info -type ok \
			-title "Finalize Giving Stimulus" \
			-message $tester(manualio,finalization) }
		set_out_handler $handler
	} elseif {[regexp "^(\[^\r\n]*)\r*\$" $line match msg} {
		messages_append $msg\n
	} else {
		puts stderr "internal error: process_out_manual_stimulus_wait_for_end cannot handle: $line"
	}
}



# {
# 			-i tester(sid,fg) -re "^(torx_ui_manual_stimulus_start)\r*\n" {
# 				messages_append $expect_out(1,string)\n
# 				set tester(manualio,message) ""
# 				# first, get the messagem and the prompt
# 				expect {
# 					-i tester(sid,fg) -re "^(torx_ui_manual_stimulus_prompt\[ \t]*(\[^ \t\n\r]*)\[ \t]*)\r*\n" {
# 						messages_append $expect_out(1,string)\n
# 						set tester(manualio,prompt) $expect_out(2,string)
# 					}
# 					-i tester(sid,fg) -re "^(\[^\r\n]*)\r*\n" {
# 						messages_append $expect_out(1,string)\n
# 						append tester(manualio,message) $expect_out(1,string)\n
# 						exp_continue
# 					}
# 				}
# 				# then,  create the dialog box, and wait for the user to press OK
# 				append tester(manualio,message) \
# 					"\n\nPress the OK button when the stimulus has been given."
# 				set tester(manualio,button) \
# 					[tk_messageBox -icon question -type ok \
# 						-title "Give Stimulus" -message $tester(manualio,message) ]
# 				# tell the tester that the user pressed OK
# 				exp_send -i $tester(sid) "$tester(manualio,prompt)\r"
# 				# finally, skip everything till the end-of-manual-stimulus message.
# 				expect {
# 					-i tester(sid,fg) -re "^(torx_ui_manual_stimulus_end)\r*\n" {
# 						messages_append $expect_out(1,string)\n
# 					}
# 					-i tester(sid,fg) -re "^(torx_ui_manual_stimulus_finalization_start)\r*\n" {
# 						messages_append $expect_out(1,string)\n
# 						set tester(manualio,finalization) ""
# 						expect {
# 							-i tester(sid,fg) -re "^(torx_ui_manual_stimulus_finalization_end)\r*\n" {
# 								messages_append $expect_out(1,string)\n
# 								after 1 { tk_messageBox -icon info -type ok \
# 									-title "Finalize Giving Stimulus" \
# 									-message $tester(manualio,finalization) }
# 							}
# 							-i tester(sid,fg) -re "^(\[^\r\n]*)\r*\n" {
# 								messages_append $expect_out(1,string)\n
# 								append tester(manualio,finalization) $expect_out(1,string)\n
# 								exp_continue
# 							}
# 						}
# 					}
# 					-i tester(sid,fg) -re "^(\[^\r\n]*)\r*\n" {
# 						messages_append $expect_out(1,string)\n
# 						exp_continue
# 					}
# 				}
# 				# we are done with the manual stimulus
# 				exp_continue
# 			}
# }

proc step_select {nr} {
	mcastsend $nr
	path_show $nr
	messages_show $nr
}

proc mouse_select_step {w x y} {
	global mouse
	global tester
	if {![info exists mouse(mouse_select_step,y)]} {
		set mouse(mouse_select_step,y) $y
	}
	set oldy $mouse(mouse_select_step,y)
	set mouse(mouse_select_step,y) $y
	set dy [winfo height $w]
#	puts stderr "mouse_select_step $w $x $y $oldy $dy"
	if {$y < 0 && $y < $oldy} {
		set idx @$x,0
		set upd -1
	} elseif {$y < 0 && $y >= $oldy} {
		return
	} elseif {$y > $dy && $y > $oldy} {
		set idx @$x,$dy
		set upd +1
	} elseif {$y > $dy && $y <= $oldy} {
		return
	} else {
		set idx @$x,$y
		set upd 0
	}
	set names [$w tag names $idx]
	foreach n $names {
# 		puts stderr "mouse_select_step ($n) (^$tester(tag,run,current),(\[0-9\]+)\$)"
		if {[regexp {^step([0-9]+)$} $n match nr] ||
		    [regexp "^$tester(tag,run,current),(\[0-9\]+)\$" $n match nr]} {
#			puts stderr "	mouse_select_step $nr"
			set nnr [expr $nr + $upd]
			if {$nnr >= 0 && $nnr <= [expr $tester(run,stepnr) + 1]} {
				step_select $nnr
				return
			}
		} else {
#			puts stderr "	mouse_select_step no match for $n"
		}
	}
	if {[llength $names] == 0} {
		set nnr [expr $tester(run,stepnr) + 1]
		step_select $nnr
	}
}

proc process_out_handle_step_output { line } {
	global tester
	if {[regexp "^((\[0-9]+) (input|output)(\\(\[^)\]*\\))?:\[ \t]+(\[^\r\n]+))\r*\$" $line match msg nr side par_chan_pco_opt event]} {
		text_append $tester(text,update) $msg\n step$nr
#		$tester(text,update) tag bind step$nr <Enter> "step_select $nr"
		set tester(run,stepnr) $nr
		label_set $tester(label,trace) $tester(var,trace) ;# for auto mode
		set tester(var,trace) ""
		entry_set $tester(entry,inst) ""
		update idletasks
	} elseif {[regexp "^(Trace: \[^\r\n]+)\r*\$" $line match msg ]} {
		set tester(var,trace) $msg
		update idletasks
	} elseif {[regexp "^(\[0-9]+ Trace\[^\r\n]+)\r*\$" $line match msg ]} {
		messages_append $msg\n
		label_append $tester(label,verdict) " Trace: INCONCLUSIVE"
		;# better than orange or DarkOrange
		# $tester(label,verdict) configure -fg coral
		$tester(label,verdict) configure -bg orange
		set tester(var,trace) ""
		update idletasks
	} elseif {[regexp "^(End of trace reached)\r*\$" $line match msg ]} {
		messages_append $msg\n
		label_append $tester(label,verdict) " Trace: PASS"
		$tester(label,verdict) configure -bg green
		set tester(var,trace) ""
		update idletasks
	} elseif {[regexp "^(torx_ui_manual_stimulus_start)\r*\$" $line match msg ]} {
		# first, get the messagem and the prompt
		set tester(manualio,message) ""
		set handler [push_out_handler "" process_out_manual_stimulus_wait_for_prompt tester(manualio,prompt)]
		# then, create the dialog box, and wait for the user to press OK
		append tester(manualio,message) \
			"\n\nPress the OK button when the stimulus has been given."
		set tester(manualio,button) \
			[tk_messageBox -icon question -type ok \
				-title "Give Stimulus" -message $tester(manualio,message) ]
		# tell the tester that the user pressed OK, and
		# skip everything till the end-of-manual-stimulus message.
		process_cmd $tester(manualio,prompt) process_out_manual_stimulus_wait_for_end tester(manualio,end)
		set_out_handler $handler
	} elseif {[regexp "^(spec disagrees with iut)\r*\$" $line match msg ]} {
		# testing_stop
		messages_append $msg\n
		if {[regexp "Trace" [label_get $tester(label,verdict)]]} {
			label_append $tester(label,verdict) " ;"
		}
		label_append $tester(label,verdict) " Test run: FAIL"
		# $tester(label,verdict) configure -fg red
		$tester(label,verdict) configure -bg red -fg white
		listbox_clear $tester(list,inputs)
		listbox_clear $tester(list,outputs)
		label_set $tester(label,menu) "Expected: "
		set tester(run,verdict) "Test run: FAIL"
		if {![string compare $tester(run,stepnr) "0"] == 0} {
			append tester(run,verdict) " ($tester(run,stepnr))"
		}
		update_title
		update idletasks
	} elseif {[regexp "^(expected(\\((\[^\(\)]*)\\))?:\[ \t]*(\[^\r\n]*))\r*\$" $line match msg ign chan event ]} {
		if {[string compare $chan ""] != 0} {
			set menu_el "($chan) $event"
		} else {
			set menu_el "$event"
			set chan out
		}
		messages_append $msg\n
		$tester(list,outputs) insert end $menu_el
		update idletasks
	} elseif {[regexp "^(\[^\r\n]*)\r*\$" $line match msg ]} {
		messages_append "$msg\n"
	} else {
		puts stderr "internal error: process_out_handle_step_output cannot handle: $line"
	}
}

proc handle_step_output { cmd } {
	global tester
	if {[info exists tester(fid)]} {
		WcSetCursor
		foreach aw [list $tester(entry,autodepth) \
		                 $tester(toggle,auto)  \
		                 $tester(toggle,autotrace)  \
		                 $tester(toggle,manual) \
		                 $tester(button,quit) \
		                 $tester(button,start) \
		                 $tester(button,stop) \
		                 $tester(menu,bar) \
		                 $tester(menu,button,file) \
		                 $tester(menu,file) \
		                 $tester(menu,button,help) \
		                 $tester(menu,help) \
		                 $tester(menu,button,mutants) \
		                 $tester(menu,mutants) \
		                 $tester(menu,button,primers) \
		                 $tester(menu,primers) \
		                 $tester(menu,button,guides) \
		                 $tester(menu,guides) \
		                 $tester(button,open,config) \
		                 $tester(button,open,trace) \
		                 $tester(button,open,log) \
		                 $tester(entry,seed) \
		                 $tester(label,seed)] {
			wcDoResetCursor $aw keep
		}
		update
		update idletasks

		process_cmd $cmd process_out_handle_step_output

		WcResetCursor
	}
}

proc testing_stop {} {
	WcSetCondInSensitive "" "" "testing *menu_but_selected_input,*menu_but_inst,*menu_but_input,*menu_but_random,*menu_but_output,*auto_toggle,*autotrace_toggle,*stop_button"
	WcSetCondSensitive "" "" "testing *start_button"
	WcSetCondSensitive "" "" "testing *open_mutants_button,*close_mutants_button,*reopen_mutants_button,*mutants,*open_primers_button,*close_primers_button,*reopen_primers_button,*primers,*open_guides_button,*close_guides_button,*reopen_guides_button,*guides,*open_trace_button,*close_trace_button,*open_log_button,*close_log_button,*open_config_button,*seed_entry,*seed_label,*startmsc_mb,*reusemsc_mb,*tools"
}
proc testing_start {} {
	WcSetCondSensitive "" "" "testing *menu_but_selected_input,*menu_but_inst,*menu_but_input,*menu_but_random,*menu_but_output,*auto_toggle,*autotrace_toggle,*stop_button"
	WcSetCondInSensitive "" "" "testing *open_mutants_button,*close_mutants_button,*reopen_mutants_button,*mutants,*open_primers_button,*close_primers_button,*reopen_primers_button,*primers,*open_guides_button,*close_guides_button,*reopen_guides_button,*guides,*open_trace_button,*close_trace_button,*open_log_button,*close_log_button,*open_config_button,*seed_entry,*seed_label,*startmsc_mb,*reusemsc_mb,*tools"
}

proc update_title {} {
	global tester
	set new_title ""
	set new_outline ""
	set sep ""
	if {![string compare $tester(initval,title,main) ""] == 0} {
		append new_title "$tester(initval,title,main)"
		set sep ": "
	}
	if {![string compare $tester(basenamebare,config_file) ""] == 0} {
		append new_title $sep
		append new_title "Config: $tester(basenamebare,config_file)"
		append new_outline "Config: $tester(basenamebare,config_file)"
		set sep " ; "
	}
	if {![string compare $tester(basenamebare,trace_file) ""] == 0} {
		append new_title $sep
		append new_title "Trace: $tester(basenamebare,trace_file)"
		append new_outline $sep
		append new_outline "Trace: $tester(basenamebare,trace_file)"
		set sep " ; "
	}
	if {![string compare $tester(basenamebare,log_file) ""] == 0} {
		append new_title $sep
		append new_title "Log: $tester(basenamebare,log_file)"
		append new_outline $sep
		append new_outline "Log: $tester(basenamebare,log_file)"
		set sep " ; "
	}
	if {![string compare $tester(basenamebare,primers_file) ""] == 0} {
		append new_title $sep
		append new_title "Primers: $tester(basenamebare,primers_file)"
		append new_outline $sep
		append new_outline "Primers: $tester(basenamebare,primers_file)"
		set sep " ; "
	}
	if {![string compare $tester(primers,titlename) ""] == 0} {
		append new_title $sep
		append new_title "Primer: $tester(primers,titlename)"
		append new_outline $sep
		append new_outline "Primer: $tester(primers,titlename)"
		set sep " ; "
	}
	if {![string compare $tester(basenamebare,guides_file) ""] == 0} {
		append new_title $sep
		append new_title "Guides: $tester(basenamebare,guides_file)"
		append new_outline $sep
		append new_outline "Guides: $tester(basenamebare,guides_file)"
		set sep " ; "
	}
	if {![string compare $tester(guides,titlename) ""] == 0} {
		append new_title $sep
		append new_title "Guide: $tester(guides,titlename)"
		append new_outline $sep
		append new_outline "Guide: $tester(guides,titlename)"
		set sep " ; "
	}
	if {![string compare $tester(basenamebare,mutants_file) ""] == 0} {
		append new_title $sep
		append new_title "Mutants: $tester(basenamebare,mutants_file)"
		append new_outline $sep
		append new_outline "Mutants: $tester(basenamebare,mutants_file)"
		set sep " ; "
	}
	if {![string compare $tester(mutants,titlename) ""] == 0} {
		append new_title $sep
		append new_title "Mutant: $tester(mutants,titlename)"
		append new_outline $sep
		append new_outline "Mutant: $tester(mutants,titlename)"
		set sep " ; "
	}
	if {![string compare $tester(var,seed) ""] == 0} {
		append new_outline $sep
		append new_outline "Seed: $tester(var,seed)"
		set sep " ; "
	}
	if {![string compare $tester(run,verdict) ""] == 0} {
		append new_outline $sep
		append new_outline "Verdict: $tester(run,verdict)"
		set sep " ; "
	}
	wm title . $new_title
	messages_outline_update	$new_outline

	reset_specs_menu ;# MUST be called before update_spec_*
	update_spec_primer
	update_spec_guide
	update_spec_mutant
	update_spec_general
	update_tools_menu
	set_specs_menu_sensitivity ;# MUST be called after update_spec_*
}

proc reset_specs_menu {} {
	global tester
	$tester(menu,specs) delete 0 end
	set i 0
	while {$i < $tester(specs,nrof)} {
		catch {unset tester(specs,$i)}
		incr i
	}
	set tester(specs,nrof) 0
}
proc update_spec_mutant {} {
	update_spec_thing mutants {SOURCEIUT IUTSOURCE} "Mutant source"
}
proc update_spec_primer {} {
	update_spec_thing primers {SOURCESPEC SPECSOURCE} "Primer source"
}
proc update_spec_guide {} {
	update_spec_thing guides {SOURCEGUIDE GUIDESOURCE} "Guide source"
}
proc update_spec_general {} {
	update_spec_thing {primers guides mutants} {SOURCE}
}
proc update_tools_menu {} {
	do_init_logmon_from_configfile LOGMON [get_config_files {primers guides mutants}]
}
proc set_specs_menu_sensitivity {} {
	global tester
	if {$tester(specs,nrof) > 0} {
		WcSetCondSensitive   "" "" "specs_present *specs_mb,*specs"
	} else {
		WcSetCondInSensitive   "" "" "specs_present *specs_mb,*specs"
	}
}


proc get_config_files {things} {
	global tester

	foreach t $things {
		if {[info exists tester(torx,cmdline,$t,config)]} {
			if {![string compare $tester(torx,cmdline,$t,config) ""] == 0} {
				append configfiles " $tester(torx,cmdline,$t,config)"
			}
		}
	}
	append configfiles " $tester(var,config_file)"
	return $configfiles
}
proc update_spec_thing {things configkey {label ""}} {
	global tester

	# puts stderr "update_spec_thing $things $configkey $label"
	# HACK: we config the "general" things (test purposes) as primers
	if {[llength $things] == 1} {
		set thing [lindex $things 0]
	} else {
		set thing ""
	}
	set configfiles [get_config_files $things]
	set file_line_strings [find_flv_list_in_configfiles $configkey $configfiles]
	foreach file_line_string $file_line_strings {
		set file ""
		if {[llength $file_line_string] > 0} {
			set file [lindex $file_line_string 0]
			set line [lindex $file_line_string 1]
			set string [lindex $file_line_string 2]
			set f [lindex $string 0]
			if {[llength $string] > 1} {
				set label [lrange $string 1 end]
			}
			if {[string compare $label ""] == 0} {
				if {[string compare $thing ""] != 0} {
					set thing_str $thing
					regsub {s$} $thing_str "" thing_str
					set thing_str [string toupper $thing_str 0 0]
					set thing_str [string tolower $thing_str 1 end]
					set label "$thing source [file tail $f]"
				} else {
					set label "Source [file tail $f]"
				}
			}
			set t [file pathtype $f]
			switch -- $t {
				  absolute -
				  volumerelative {
				  	set file $f
				} relative {
					set dir [file dirname $file]
				  	set file [file join $dir $f]
				} default {
					 Message "update_spec_thing: unexptected path type: $t for file: $f\n"
				}
			}
		}	
		# Message "update_spec_thing($thing)($configkey):($file_line_string)($file)\n"
		if {[file exists $file]} {
			set thing $tester(specs,nrof)
			incr tester(specs,nrof)
			set tester(specs,$thing) $file
			$tester(menu,specs) add command \
				-label $label \
				-command "do_show_spec_thing $thing"
		}
	}
}
# =========================================================================

# =========================================================================

# The routine check_tester_eof checks whether torx is still
# running, or has produced end-of-file.
# It will disable all polling on end-of-file that was enabled
# by poll_tester_eof .
# Usually, check_tester_eof is called at the start of a callback routine,
# and poll_tester_eof is called at the end of a callback routine.
proc check_tester_eof {fn} {
	global tester
	Debug_FnGlobals check_tester_eof "start($fn)" {tester} \
	                tester(count,busy) tester(killing) tester(fid)

	if {[info exists tester(killing)]} {
		if {[info exists tester(fid)]} {
			unset tester(fid)
		}
	}
	if {[info exists tester(fid)]} {
		if {$tester(count,busy) <= 0} {
	
			# check quickly for end-of-file
			Debug_Msg check_tester_eof "just before calling expect"
			Debug_Msg check_tester_eof "just after calling expect"
			
		}
	}
	incr tester(count,busy)

	Debug_FnGlobals check_tester_eof "end($fn)" {tester} \
	                tester(count,busy) tester(killing) tester(fid)
}

# The routine poll_tester_eof will repeatedly poll whether torx is still
# running, or has produced end-of-file.
# For this, it uses expect_background, indirectly, by enabling
# the expect_background commands that are 'made' in do_startTester,
# to poll for end-of-file .
# The polling will be disabled by check_tester_eof .
# Usually, check_tester_eof is called at the start of a callback routine,
# and poll_tester_eof is called at the end of a callback routine.
# NOTE: we intend to unset tester(fid) at the end of the 'running'
# callback routine, i.e. the one that resets tester(count,busy) to 0,
# because we want that running callback routine to really finish
# its work and consume all torx output. We don't want to 'disrupt'
# a callback routines at the bottom of the invocation stack by
# unsetting tester(fid) at the end of a callback routine 'higher up'
# on the invocation stack.
# To debug this behaviour, enable the following in the main routine,
# because they nicely show the invocations:
#    set debug(FnGlobals,check_tester_eof) 1
#    set debug(FnGlobals,poll_tester_eof) 1
#    set debug(Msg,setup_expect_handlers) 1
# 
proc poll_tester_eof {fn} {
	global tester
	Debug_FnGlobals poll_tester_eof "start($fn)" {tester} \
	                tester(count,busy) tester(killing) tester(fid)

	incr tester(count,busy) -1
	if {[info exists tester(fid)]} {
		if {($tester(count,busy) == 0)} {

			# finally, unset tester(fid) if needed
			if {[info exists tester(killing)]} {
				unset tester(fid)
			}
		}
	}

	Debug_FnGlobals poll_tester_eof "end($fn)" {tester} \
	                tester(count,busy) tester(killing) tester(fid)
}

proc handle_tester_eof {buf} {
	global tester
    Debug_FnArgs handle_tester_eof $buf
    Debug_Stack handle_tester_eof $buf
	
	Debug_Msg handle_tester_eof "just before: set tester(run,active) 0"
	set tester(run,active) 0
	Debug_Msg handle_tester_eof "just before: info exists tester(fid)"
	if {[info exists tester(fid)]} {
		unset tester(fid)
	}
	Debug_Msg handle_tester_eof "just before: info exists tester(fid,wait)"
	if {[info exists tester(fid,wait)]} {
		Debug_Msg handle_tester_eof "just before: wait fid"
		# do NOT wait, because this will trigger a tcl/expect error:
		#   Tcl_RegisterChannel: duplicate channel names
		# close -i $tester(fid,wait)
		# wait -i $tester(fid,wait)
		unset tester(pid)
		unset tester(fid,wait)
	}
	Debug_Msg handle_tester_eof "just before: update"
	update ;# try to catch all stderr output first
	update idletasks ;# try to catch all stderr output first
	Debug_Msg handle_tester_eof "just after: update"
	Debug_Msg handle_tester_eof "just before: testing_stop"
	testing_stop
	messages_append "$buf\n"
	messages_append "End of test run\n"
	messages_run_end
	set tester(run,ready) 1
    Debug_FnRes handle_tester_eof
}


proc file_mk_absolute {filename dirname} {
	if {[string compare [file pathtype $filename] absolute] == 0} {
		return $filename
	} else {
		return [file join $dirname $filename]
	}
}

# =========================================================================
