# =========================================================================
# $Id: widgetaccess.tcl,v 1.1.2.5 2004/10/06 15:08:40 belinfan Exp $
# =========================================================================
#
# Routines that give access to widgets, to retreive or set values
#

proc text_append {w text {tags {}}} {
	if {[winfo exists $w]} {
		set state [$w cget -state]
		$w configure -state normal
		$w insert end $text $tags
## This commented-out code would be necessary if we could not use the
## tags as we do above.
#		catch {$w tag delete tag,justInserted}
#		$w insert end $text tag,justInserted
#		foreach t $tags {
#			$w tag add $t tag,justInserted.first tag,justInserted.last
#		}
		$w configure -state $state
		$w see end
	}
}
proc text_replace {w from to text {tags {}}} {
	if {[winfo exists $w]} {
		set state [$w cget -state]
		$w configure -state normal
##		set tags [$w tag names $from]
		$w delete $from $to
		$w insert $from $text $tags
## This commented-out code would be necessary if we could not use the
## tags as we do above.
#		catch {$w tag delete tag,justInserted}
#		$w insert end $text tag,justInserted
#		foreach t $tags {
#			$w tag add $t tag,justInserted.first tag,justInserted.last
#		}
		$w configure -state $state
		$w see end
	}
}
proc text_clear {w} {
	if {[winfo exists $w]} {
		set state [$w cget -state]
		$w configure -state normal
		$w delete 1.0 end
		$w configure -state $state
	}
}
proc text_get {w} {
	set text ""
	if {[winfo exists $w]} {
		set text [$w get 1.0 end]
		if {[regsub "\n$" $text "" changed]} {
			set text $changed
		}
	}
	return $text
}

proc text_unbacklight {w tag} {
	# puts stderr "text_unbacklight $w $tag"
	set bg [lindex [$w configure -background] 3]
	$w tag configure $tag -background $bg

}
proc text_backlight {w tag} {
	# puts stderr "text_backlight $w $tag"
	$w tag configure $tag -background "#ffffef"
	# or: "#fafaff"
}
proc text_seebacklight {w tag} {
	set ranges [$w tag ranges $tag]
	if {[llength $ranges] > 0} {
		set s [lindex $ranges 0]
		set e [lindex $ranges end]
#		puts stderr "ranges($w,$tag): s=$s e=$e  $ranges"
		if {[string compare $e ""] != 0 && [string compare $s ""] != 0} {
			$w see $e
			$w see $s
		}
	}
}

proc entry_set {w s} {
	set text ""
	if {[winfo exists $w]} {
		set state [$w cget -state]
		$w configure -state normal
		$w delete 0 end
		$w insert 0 $s
		$w configure -state $state
	}
}
proc entry_get {w} {
	set text ""
	if {[winfo exists $w]} {
		set text [$w get]
	}
	return $text
}
proc listbox_get_selection {w} {
	set text ""
	if {[winfo exists $w]} {
		set selection [$w curselection]
		if {$selection != ""} {
			set text [$w get $selection]
		}
	}
	if {[regsub "\n*$" $text "" changed]} {
			set text $changed
	}
	return $text
}
proc listbox_clear {w} {
	if {[winfo exists $w]} {
		$w delete 0 end
	}
}
proc label_append {w s} {
	if {[winfo exists $w]} {
		set text [WcGetLabel $w]
		WcSetLabel $w $text$s
	}
}
proc label_clear {w} {
	if {[winfo exists $w]} {
		WcSetLabel $w ""
	}
}
proc label_set {w s} {
	if {[winfo exists $w]} {
		WcSetLabel $w $s
	}
}
proc label_get {w} {
	set text ""
	if {[winfo exists $w]} {
		set text [WcGetLabel $w]
	}
	return $text
}
proc toggle_set {w v} {
	global wcl ;# dirty!!!
	if {[winfo exists $w]} {
		set var [$w cget -variable]
		set $var $v
	}
}
proc check_get {w} {
	global wcl ;# dirty!!!
	set result ""
	if {[winfo exists $w]} {
		set var [$w cget -variable]
		set result [set $var]
	}
	return $result
}

proc Message {s} {
	global tester
	# label_set $tester(label,error) $s
	catch {puts stderr "Message: $s"}
	
}

# =========================================================================
