/***** trojka: tan-engine.h *****/

/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */
/* This software is for educational purposes only.                        */
/* Permission is given to distribute this code provided that this intro-  */
/* ductory message is not removed and no monies are exchanged.            */
/* No guarantee is expressed or implied by the distribution of this code. */
/* Software written by Gerard J. Holzmann as part of the book:            */
/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */
/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */
/* Send bug-reports and/or questions to: gerard@research.att.com          */

/*	Modified code and additional routines for the trojka analyser	*/
/*	No guarantee is expressed or implied!				*/
/*									*/
/* No permission is given to distribute the modified code and		*/
/* additional routines without permission of the author.		*/
/*									*/
/* Modified code and additional routines written by Rene G. de Vries	*/
/*									*/
/* trojka analyser engine						*/
/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/
/*----------------------------------------------------------------------*/


#ifndef H_TANENGINE
#define H_TANENGINE

#ifdef TANSTATIC
#include "tan-sman.h"
#endif

/* actions for transact (tan.r) and do_with_spec (tan-engine) */
#define SET     1
#define MOVE    2
#define OBS     3
#define DMOVE   4
#define AMOVE   5
#define ADD     6

/* serveral tags for actions */
#define TAU     0
#define INPUT   1
#define OUTPUT  2
#define BLOCKED 3


#ifndef uchar
#define uchar   unsigned char
#endif

/* declaration of depth when a branch is cut */
int Maxdiepte	= 0;	/* default; 0 means infinite */

/* declaration of global vars used by tan.[chr] */
int observable;

/* declaration of global status-variables */

int	cut;		/* number of cut branches after engine-call */
int	reacheddepth;	/* maximum reached depth after engine-call */
int	executed;	/* number of executed io-actions after engine-call */
int	matched;	/* number of matched states after engine-call */
int	analyse;	/* number of analysed states after engine-call */


/* prototypes */
		
void
do_with_spec(	StateSetT**,	/*inout: superstate */
		uchar,		/*in: command */	
		uchar*		/*out: deltasuspension */
		);

#endif
