static char *enginec[]  = { /* trojka engine routines */
"/***** trojka: tan-sman.c *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka analyser state manager					*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"/*----------------------------------------------------------------------*/",
"",
"/* === declaration of hidden datatypes and variables === */",
"",
"#include <stdio.h>",
"",
"#ifdef TANSTATIC",
"#include \"tan-sman.h\"	",
"#endif",
"",
"StateSetT *ssbag        = NULL; /* global bag of unused statevectors */",
"StateSetT **T_tab       = NULL; /* Global hashtable of statevectors */",
"StateStrT *stbag	= NULL; /* Global bag of unused state-structures */ ",
"StateStrT *stroot	= NULL; /* root of statestructure link */",
"",
"int createdstates	= 0;	/* number of created slots to store */",
"				/* statevectors */",
"int createdstructs	= 0;	/* number of created slots to store */",
"				/* structures of statevectors */",
"/* === procedures and functions (private aswell public) === */",
"",
"StateSetT *",
"SSfree() /* return a free statevector from ssbag */",
"{	StateSetT *sstate;",
"	if (!ssbag)	/* none, so create one */	",
"	{	sstate = (StateSetT *) emalloc(sizeof(StateSetT));",
" 		sstate->body = (char *) emalloc(sizeof(State));  /* maximum */ ",
"",
"		createdstates++; /* count number of created vectors */",
"	}",
"	else {	/* well, there's something left */",
"		sstate = ssbag;",
"		ssbag = ssbag->nxt;",
"		sstate->nxt = NULL;",
"		sstate->vsize = 0;",
"	}",
"	return sstate;",
"}",
"",
"StateStrT *",
"STfree() /* return a free structure from stbag */",
"{	StateStrT *sstruc;",
"	if (!stbag)	/* none, so create one */	",
"	{	sstruc = (StateStrT *) emalloc(sizeof(StateStrT));",
"		createdstructs++;",
"	}",
"	else {	/* well, there's something left */",
"		sstruc = stbag;",
"		stbag = stbag->nxt;",
"	}",
"	sstruc->nxt  = NULL;	/* defaults values */",
"	sstruc->last = NULL;",
"	sstruc->nr_users = 0;",
"	return sstruc;",
"}",
"			",
"int",
"SSismember(StateSetT **superstate, State *state, int size, char *p, char *q,",
"	   uchar *delta)",
"/* return if state is member of the supervector state and corsponding delta*/",
"{	StateSetT *sstate;",
"	int m;",
"",
"	for (sstate=*superstate;sstate;sstate = sstate->nxt) {",
"	m = memcmp((char *)sstate->body,(char *)state,size);",
"		if (m==0 && size==sstate->vsize &&",
"		   (memcmp((char *) sstate->struc->proc_struct, p, \\",
"			(state->_nr_pr)*sizeof(int)) == 0) &&",
"		   (memcmp((char *) sstate->struc->q_struct, q, \\",
"			(state->_nr_qs)*sizeof(int))==0))",
"		   {	*delta = sstate->delta;",
"			return 1; /* is member */",
"		   }",
"		else if (m<0) break;",
"	 }",
"	 return 0;",
"}",
"",
"void",
"SSaddstate(	StateSetT **superstate,	/* io */ ",
"	 	State *state,		/* in */",
"	 	int size,		/* in */",
"		char *p,		/* in: proc_offset */",
"		char *q,		/* in: q_offset */",
"		uchar delta		/* in: delta */",
"	)",
"{	StateSetT *tmp, *ostate = NULL, *ntmp;",
"	StateStrT *sstruc, *ostruc = NULL, *nstruc;",
"	int m;",
"",
"	if (!*superstate) *superstate = tmp = SSfree();",
"	else {",
"	    for (tmp=*superstate;tmp;ostate = tmp, tmp = tmp->nxt) {",
"	    m = memcmp((char *)tmp->body,(char *)state,size);",
"		if (m==0 && size==tmp->vsize && \\",
"		   (memcmp((char *) tmp->struc->proc_struct, p, \\",
"			(state->_nr_pr)*sizeof(int)) == 0) && \\",
"		   (memcmp((char *) tmp->struc->q_struct, q, \\",
"			(state->_nr_qs)*sizeof(int))==0))",
"			return; /* already a member */",
"		else if (m<0) ",
"		{	ntmp = SSfree();",
"			ntmp->nxt = tmp;",
"			if (!ostate) *superstate = ntmp;",
"			else	ostate->nxt = ntmp;",
"			tmp = ntmp;",
"			break;		",
"		}",
"		else if (!tmp->nxt)",
"		{	tmp->nxt = SSfree();",
"			tmp = tmp->nxt;",
"			break;",
"		}",
"	     }",
"	}",
"	tmp->vsize = size;	/* copy the items */",
"	tmp->delta = delta;",
"	memcpy((char *)(tmp->body), state, size);",
"	if (!stroot) stroot = sstruc = STfree();",
"	else",
"	for (sstruc=stroot;sstruc;ostruc = sstruc, sstruc = sstruc->nxt) {",
"",
"	m = memcmp((char *) (sstruc->proc_struct), p,",
"		(state->_nr_pr)*sizeof(int));",
"	if (m==0 && \\",
"	    memcmp((char *) (sstruc->q_struct), q, ",
"		(state->_nr_qs)*sizeof(int)) == 0) ",
"		{	tmp->struc = sstruc;	 /* is member */",
"			sstruc->nr_users += 1;",
"			return;",
"		}",
"	else if (m<0) ",
"	{	nstruc = STfree();",
"		nstruc->nxt  = sstruc;",
"		nstruc->last = sstruc->last;	/* beware: double linked! */",
"		sstruc->last = nstruc;",
"		if (!ostruc) stroot = nstruc;",
"		else ostruc->nxt = nstruc;",
"		sstruc = nstruc;",
"		break;",
"	}",
"	else if (!sstruc->nxt)",
"	{	sstruc->nxt  = STfree();",
"		sstruc->nxt->nxt = NULL;",
"		sstruc->nxt->last = sstruc;",
"		sstruc = sstruc->nxt;",
"		break;",
"	}",
"	} /* all possible members */",
"	tmp->struc = sstruc;",
"	memcpy((char *) tmp->struc->proc_struct, p, MAXPROC*sizeof(int));",
"	memcpy((char *) tmp->struc->q_struct, q, MAXQ*sizeof(int));",
"	tmp->struc->nr_users += 1;",
"} /*addstate*/",
"",
"void",
"SSclear (StateSetT **superstate)",
"/* empty superstate and release all statevectors to everybody */ ",
"{	StateSetT *sstate, *ostate = NULL;			",
"	if (*superstate) {	/* anything to do? */",
"		for (sstate=*superstate;(sstate);ostate=sstate,",
"					sstate=sstate->nxt) ",
"		if(! --(sstate->struc->nr_users)) {",
"			/* we may dispose the structure info */",
"			if (!sstate->struc->last)	/* stroot? */",
"			   stroot = sstate->struc->nxt;",
"			else 			",
"			   sstate->struc->last->nxt = sstate->struc->nxt;",
"			if (sstate->struc->nxt) /* not last item of chain */",
"			   sstate->struc->nxt->last = sstate->struc->last;",
"			sstate->struc->nxt = stbag;	/* release to stbag */",
"			stbag = sstate->struc;",
"			}",
"	 	ostate->nxt=ssbag;  /* release to free space */",
"	 	ssbag = *superstate;",
"	 	*superstate = NULL;",
"		}",
"}",
"",
"",
"void",
"SSmerge(StateSetT **Dsuperstate,	/* io */",
"	StateSetT **superstate		/* io */)",
"/* merge superstate to Dsuperstate, superstate will be empty */",
"{	StateSetT *sstate, *tmp;",
"	uchar dummy;",
"",
"	if (*superstate) {	/* something to do */",
"	 sstate = *superstate;",
"	 while (sstate) {",
"		tmp = sstate;",
"		sstate=sstate->nxt;",
"		/* doubles will be disposed by SSaddstate */",
"	 	SSaddstate(Dsuperstate, (State *) tmp->body,",
"				tmp->vsize,",
"				(char *) tmp->struc->proc_struct,",
"				(char *) tmp->struc->q_struct,",
"				tmp->delta);",
"		tmp->nxt = NULL;",
"		SSclear(&tmp);",
"		}",
"	*superstate = NULL;",
"	}",
"}",
"",
"void ResState(StateSetT*);",
"",
"int",
"SSnrel (StateSetT **superstate)",
"/* return the number of elements in superstate*/ ",
"{	StateSetT *sstate;",
"	int count =0,i;			",
"	if (*superstate) 	/* anything to do? */",
"	 for (sstate=*superstate;sstate;sstate=sstate->nxt)",
"		{ count++;",
"		}",
"	return count;",
"}	",
"",
"void",
"Tinit(void)",
"{",
"T_tab = (StateSetT **) emalloc((1<<ssize) * sizeof(StateSetT *));",
"}",
"",
"void ",
"Trelease()",
"/*release all used space to ssbag */",
"{ int i;",
"  for(i=0;i<=mask;i++) SSclear(&T_tab[i]);",
"  truncs = 0;",
"}",
"",
"void",
"Tstore(State *vin /* state */, int nin /*size*/, int *p, int *q, uchar delta) ",
"{",
"	s_hash((uchar *)vin, nin);",
"	SSaddstate(&T_tab[j1], vin, nin, (char *) p, (char *) q, delta);",
"",
"}",
"",
"",
"int",
"Thit(State *vin /* state */, int nin /*size*/, int *p, int *q, uchar *delta) ",
"{",
"	s_hash((uchar *)vin, nin);",
"	return SSismember(&T_tab[j1], vin, nin, (char *) p, (char *) q, delta);",
"}",
"",
"",
"void    ",
"IncludeState(StateSetT **Set)   /* saves state and context in Set  */",
"{",
"        SSaddstate(Set, &now, vsize, (char *) proc_offset,",
"                         (char *) q_offset, 0 /*DUMMY*/);",
"}",
"",
"void",
"ResState(StateSetT *State)      /* restores state State in now ect. */",
"/* restore State */",
"{       if (State) {",
"                vsize = State->vsize;",
"                memcpy((char *) &now, State->body, vsize);",
"                memcpy((char *) proc_offset, State->struc->proc_struct,",
"                        MAXPROC*sizeof(int));",
"                memcpy((char *) q_offset, State->struc->q_struct,",
"                        MAXQ*sizeof(int));",
"        }",
"}",
"/***** trojka: tan-engine.c *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"/*	Modified code and additional routines for the trojka analyser	  */",
"/*	No guarantee is expressed or implied!				  */",
"/*									  */",
"/* No permission is given to distribute the modified code and		  */",
"/* additional routines without permission of the author.		  */",
"/*									  */",
"/* Modified code and additional routines written by Rene G. de Vries	  */",
"/**************************************************************************/",
"/* trojka analyser engine						",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		",
" * version 2.0b:        Thu Nov 14 17:06:36 MET 2002             ",
" *                      cleaned and making it tarjan            ",
" * version 2.1:         Thu Jun 17 13:24:33 CEST 2004",
" *                      code cleanup.",
" *",
" *",
" */",
"/*------------------------------------------------------------------------*/",
"",
"#include \"tan.r\"",
"",
"char",
"dotransition(Trans *t, short II, int n)",
"{	char m;",
"	short tt = (short) ((P0 *) pptr(II))->_p;",
"#define continue	return 0",
"#define this 		pptr(II)",
"#include \"tan.m\"",
"P999:	return 1;",
"#undef continue",
"#undef this",
"}",
"",
"void",
"undotransition(Trans *t, short II, int n)",
"{	char m;",
"	short   tt = (short) ((P0 *) pptr(II))->_p;",
"#define continue goto R999",
"#define this	pptr(II)",
"#include \"tan.b\"",
"R999: /*EMPTY*/ ; /* AFEB added this semicolon */",
"#undef continue",
"#undef this",
"}",
"		",
"void",
"do_with_spec(	StateSetT **superstate, /*inout: superstate */",
"		uchar com,		/*in: command */	",
"		uchar *gamma		/*out: deltasuspension */",
"		)",
"/* predict all possible action from a state",
"   in: superstate vector representing the reduced observed state. ",
"	com   : in - command (ADD/AMOVE/DMOVE)",
"	gamma : out - true is a deltasuspention is found",
" ",
"*/",
"",
"{",
"int		actioncounter = 0;",
"#ifdef RGVTEXT",
"int		counter_S;",
"char *lmsg; /* nice info for logging */",
"#endif",
"int		diepte, i, dieptewarned;",
"short		firstproc = 0;",
"short		lastproc;",
"uchar		delta, inaction;",
"char		n;		/* no idee what this does */",
"short		Pselect,	/* selected process */",
"		Pprocstate;	/* state of selected process */",
"char		Pproctype;	/* type of selected process */",
"Trans		*option;	/* action to execute */",
"uchar		*action;	/* pointer to variables in statevector */",
"StateSetT	*sstate	= NULL,	/* current selected element from superstate */ ",
"		*Temp	= NULL,		/* temporal */",
"		*Result	= NULL;		/* result after action-execution */",
"",
"Trelease();	/* start all over with hashing, i.e. Mathed set is empty */",
"cut = 0;	/* cuts initial zero */",
"reacheddepth = 0;",
"executed = 0;",
"matched = 0;",
"analyse = 0;	/* intial zero */",
"*gamma = 0;	/* initial no delta-suspension */",
"dieptewarned = 0;",
"",
"#ifdef RGVTEXT",
"",
"counter_S = 0; /* for counting superstates logging */",
"",
"switch (com) {",
"   case ADD: lmsg=\"Engine command: searching for Menu\";break;",
"   case AMOVE: lmsg=\"Engine command: determing S'=S AFTER x\";break;",
"   case DMOVE: lmsg=\"Engine command: termining S'=S AFTER Quienscence\";break;",
"}",
"logprintf(\">T-Engine< superstate S has %%d elements\\n\\t %%s\\n\",",
"SSnrel(superstate),lmsg);",
"",
"#endif /* ifdef RGVTEXT */",
"",
"for (sstate=*superstate;sstate;sstate=sstate->nxt) {",
"   ResState(sstate);	/* set context */",
"",
"#ifdef RGVTEXT",
"   counter_S++;",
"   logprintf(\">T-Engine< Select superstate element %%d\\n\",counter_S);",
"#endif /* ifdef RGVTEXT */",
"",
"   if (com==DMOVE) SSclear(&Temp);",
"   diepte = 0;",
"   firstproc = 0;",
"   lastproc = now._nr_pr-1;",
"",
"Beneden:",
"   if (Maxdiepte && (diepte >= Maxdiepte))",
"   {",
"",
"	",
"   if (!dieptewarned) {",
"       fprintf(stderr, \"Cut of branch at depth %%d; use -m flag to increase search depth\\n\",diepte);",
"       dieptewarned = 1;",
"   }",
"#ifdef RGVTEXT",
"   logprintf(\">T-Engine< Cut of branche at depth %%d \\n\",diepte);",
"#endif",
"   cut++;",
"   goto Omhoog;",
"   }",
"",
"   if (firstproc==0)",
"     if (Thit(&now, vsize, proc_offset, q_offset, &delta))",
"       {",
"	 matched++;",
"",
"	 if (diepte > 0) {",
"",
"#ifdef RGVTEXT",
"	 logprintf(\">T-Engine< state collision: (regular) state already done \\n\");",
"#endif",
"",
"	 goto Omhoog;",
"	 } else {  ",
"",
"#ifdef RGVTEXT",
"	   logprintf(\">T-Engine< state collision: super state already done \\n\");",
"#endif",
"	   continue;",
"	 }",
"       }",
"  		",
"   /* mark state that is under investigation (state matching ala tarjan */",
"",
"   Tstore(&now, vsize, proc_offset, q_offset, delta);   ",
"   delta = 1;	/* PAS HIER ANDERS FOUTEN ! */",
"   analyse++;	/* increment nr of analysed states */",
"",
"#ifdef RGVTEXT",
"   logprintf(\">T-Engine< current state: %%d processes\\n\",lastproc);",
"#endif ",
"",
"Wederom:",
"   for (Pselect = lastproc; Pselect >= firstproc; Pselect -= 1)",
"     {",
"#ifdef RGVTEXT",
"       logprintf(\">T-Engine< Select process %%d, investigating options\\n\",Pselect);",
"#endif ",
"       action = pptr(Pselect);",
"       Pproctype = (unsigned char) ((P0 *) action)->_t;",
"       Pprocstate = (short) ((P0 *) action)->_p;		",
"       trpt->o_pm &=  0; /* no move in this pid yet, supports else */",
"       for (option = trans[Pproctype][Pprocstate];option;option=option->nxt) ",
"	 {",
"	   transact(option,Pselect,n,OBS);	/* set observable variable */",
"	   switch (observable) {",
"",
"	   case INPUT:",
"#ifdef RGVTEXT",
"	     logprintf(\">T-Engine< depth %%d, selected process %%d, obs.input action %%s [%%d], else is %%s possible\\n\",",
"		       diepte, Pselect, option->tp, option->forw,",
"		       (trpt->o_pm&1)?\"not\":\"still\");",
"#endif				",
"	     trpt->o_pm |= 1; /* we moved (else solver */",
"	     switch (com) {",
"	     case DMOVE:",
"	       inaction = 1;",
"	       break; /* case INPUT/DMOVE */",
"	     case ADD:",
"	       transact(option,Pselect,n,ADD);",
"	       break; /* case INPUT/ADD */",
"	     case AMOVE:",
"	       if (fldval[0] > 0) { /* input move ? */",
"		 IncludeState(&Temp);",
"		 if (transact(option,Pselect,n,MOVE)) {",
"		   executed++;",
"		   if (option->st) /* MOVE */",
"		     ((P0 *)action)->_p = option->st;",
"		   IncludeState(&Result);",
"		 } ",
"		 ResState(Temp);",
"		 SSclear(&Temp); /* restore context to return */",
"	       }",
"	       break; /* case INPUT/AMOVE */",
"",
"	     }",
"	     break; /* case INPUT */",
"",
"	   case OUTPUT:",
"#ifdef RGVTEXT",
"	     logprintf(\">T-Engine< depth %%d, selected process %%d, obs.output action %%s [%%d], else is %%s possible\\n\",",
"		       diepte, Pselect, option->tp, option->forw,",
"		       (trpt->o_pm&1)?\"not\":\"still\");",
"#endif",
"	     trpt->o_pm |= 1; /* we moved (else solver */",
"	     switch (com) {",
"	     case ADD:",
"	       transact(option,Pselect,n,ADD);",
"	       break;",
"	     case DMOVE:",
"	       delta = 0;",
"	       break;",
"	     case AMOVE:",
"	       if (fldval[0] < 0) { /* output move ? */",
"		 IncludeState(&Temp);",
"		 if (transact(option,Pselect,n,MOVE)) {",
"		   executed++;",
"#ifdef RGVTEXT",
"		   fprintf(stderr, \"Execute action: %%s\\n\",option->tp);",
"#endif",
"		   if (option->st) /* MOVE */",
"		     ((P0 *)action)->_p = option->st;",
"		   IncludeState(&Result);",
"		 }",
"		 ResState(Temp);",
"		 SSclear(&Temp); /* restore context to return */",
"	       }",
"	       break;",
"	     }",
"	     delta= 0;",
"	     break; /* OUTPUT */",
"			",
"	   case BLOCKED:	{",
"#ifdef RGVTEXT",
"	     logprintf(\">T-Engine< Selected process %%d, blocked action %%s [%%d], else is %%s possible\\n\",",
"		       Pselect, option->tp, option->forw, (trpt->o_pm&1)?\"not\":\"still\");",
"#endif",
"	     break; /* no inout nor output during RV-SYNC */",
"	   }",
"			",
"	   case TAU:			                ",
"	     if (!dotransition(option,Pselect,n)){",
"#ifdef RGVTEXT",
"	       logprintf(\">T-Engine< depth %%d, selected process %%d, non executable tau action %%s [%%d], else is %%s possible\\n\",",
"			 diepte, Pselect, option->tp,",
"			 option->forw, (trpt->o_pm&1)?\"not\":\"still\");",
"#endif",
"	       break; /* TAU */",
"	     }",
"",
"	     else {",
"	       trpt->o_pm |= 1; /* we moved (else solver) */",
"#ifdef RGVTEXT",
"	       logprintf(\">T-Engine< depth %%d,selected process %%d, executable tau action %%s [%%d], else is %%s possible\\n\",",
"			 diepte, Pselect, option->tp, option->forw,",
"			 (trpt->o_pm&1)?\"not\":\"still\");",
"#endif",
"",
"	       /* support for the new definition of ioco",
"		*",
"		* subtile handling of boq-quiescence */",
"	       /* only mark quiescence when we are not blocked in a RV; this state was unstable  */",
"	       /* we only set the delta in going up; because of the the RV handing.",
"		 delta = 0; 		",
"	       */ ",
"",
"	       diepte++;depth++;trpt++;",
"",
"	       /* do some bookkeeping */",
"	       trpt->pr = Pselect; trpt->st = Pprocstate;",
"	       if (option->st) /* setting new state */",
"		 ((P0 *)action)->_p = option->st;",
"",
"	       trpt->o_t = option;trpt->o_n = n;",
"	       trpt->o_ot = Pproctype; trpt->o_tt = Pprocstate;",
"	       trpt->o_To = firstproc;",
"	       trpt->o_delta = delta; trpt->o_inaction = inaction;",
"",
"	       if (option->atom&2) /* atomic action */",
"		 {lastproc=firstproc=Pselect;nlinks++;}",
"	       else { lastproc = now._nr_pr-1; firstproc = 0;}	",
"",
"	       goto Beneden;	",
"					}",
"	   } /* switch observable */",
"	   continue;",
"",
"Omhoog:	/* restore last state bookkeeping */",
"	   option = trpt->o_t /* restore old option for undo */;",
"",
"#ifdef RGVTEXT",
"	   logprintf(\">T-Engine< Current state investigated, going backwards depth %%d => depth %%d\\n\",",
"		     diepte, diepte-1);",
"#endif",
"	   /* okay we are going up;",
"	    * are we now in a RV case; so then no quiensce should be detected.",
"	    * otherwise we always can conclude that there was a tau; so instable state",
"	    * and delta should be set.",
"	    */",
"	   if (boq==-1)",
"	     delta = 0; /* always since there was an internal step */",
"	   n = trpt->o_n /* no idee, but do it anyway */;",
"	   Pproctype = trpt->o_ot /* restore old proctype */;",
"	   Pprocstate = trpt->o_tt /* restore old procstate */;",
"	   Pselect = trpt->pr; /*restore old procselected */;",
"",
"	   action = pptr(Pselect);",
"	   firstproc = trpt->o_To; /* restore old firstproc */;",
"	   undotransition(option,Pselect,n); /* undo action */;",
"	   depth--;trpt--;diepte--;",
"	   ((P0 *)action)->_p = Pprocstate;",
"",
"	 } /* all options */",
"     } /* all processes */",
"",
"",
"if (boq == -1) {",
"  /* only add state when we are in nonblocked mode (boq) */",
"  *gamma = (*gamma || delta); /* set delta */",
"",
"  if (com==DMOVE && delta) {",
"    IncludeState(&Result);	/* this should be delivered */	",
"  }",
"}",
"",
" if (reacheddepth < diepte) reacheddepth = diepte;	",
"",
" if (diepte >0) goto Omhoog /* stack is not empty */;",
"",
" if (com==DMOVE) SSmerge(&Result,&Temp);	/* add pending results */",
"",
"} /* all superstate-elements */",
"",
" if (com==DMOVE || com==AMOVE) {",
"   SSclear(superstate);",
"   SSmerge(superstate,&Result);	/* return result */",
" }",
"}",
"/***** trojka: tan-action.c *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka analyser action handler					*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"/*----------------------------------------------------------------------*/",
"",
"#include <stdio.h>",
"",
"#ifdef TANSTATIC",
"#include \"tan-action.h\"",
"#endif",
"",
"/* prototypes (pan.c */",
"char    *emalloc(unsigned);     /* never released or reallocated memory proc */",
"",
"/* Global declarations */",
"",
"IActionT setAction;		/* help to pass to trojka.h */",
"IActionT *abag		= NULL;	/* Global bag of unused actionvectors */",
"IActionT *aroot		= NULL; /* root of actionvector-list */",
"short	 actionident	= 0;	/* global action-counter */",
"",
"void",
"Addaction(uchar queue, AtypeT atype, char *text)",
"{	int	i;",
"	IActionT *tmp;",
"	for (tmp = aroot;tmp;tmp = tmp->nxt) {",
"		if (queue == tmp->Queue && \\",
"		   (memcmp(tmp->sfield, G_sfield,  sizeof(fieldT)*G_nrfields))==0)",
"		    for (i=0;i<G_nrfields;i++) {",
"			if (tmp->sfield[i]==solid && G_vfield[i]!=tmp->vfield[i]) break;",
"			if (i==G_nrfields-1) return; /* double action */",
"			}",
"	",
"	}",
"	/* oke, new action */",
"	if (!abag) tmp = (IActionT *) emalloc(sizeof(IActionT)); ",
"	else	{ /* use an old one */",
"		tmp = abag;",
"		abag = tmp->nxt;",
"		}",
"	tmp->nxt = aroot;",
"	aroot = tmp;",
"	tmp->aident = ++actionident;",
"	tmp->atype = atype;",
"	tmp->Queue = queue;",
"	tmp->string = text;",
"	tmp->Qtype = G_Qtype;",
"	tmp->nr_fields = G_nrfields;",
"	memcpy(tmp->sfield,G_sfield,sizeof(fieldT)*G_nrfields);",
"	memcpy(tmp->vfield,G_vfield,sizeof(int)*G_nrfields);",
"}",
"",
"void",
"ClearAction(void)",
"{",
"	IActionT *tmp;",
"	if (aroot) {",
"		for  (tmp = aroot; tmp->nxt; tmp=tmp->nxt);",
"		tmp->nxt = abag;",
"		abag = aroot;",
"		}",
"	aroot = NULL;",
"	actionident = 0;",
"}",
"				",
"void",
"PrtAction(FILE *out, int actionnr)",
"{",
"	IActionT *tmp;",
"	for (tmp=aroot; tmp->aident!=(short) actionnr;tmp=tmp->nxt);",
"	fprintf(out, \"%%s %%-25s\\t\",(tmp->atype==input)?\"input: \":\"output:\",",
"		tmp->string);",
"	if (tmp->atype==input)",
"		qrecvprt(out,tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);",
"	else ",
"		qsendprt(out,tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);",
"}	",
"",
"ActionT",
"SetAction(int actionnr)",
"{	ActionT	 Result;",
"	IActionT *tmp;",
"	int i;",
"",
"	for (tmp=aroot; tmp->aident!=(short) actionnr;tmp=tmp->nxt);",
"	if (tmp->atype==input)",
"		qrecvset(tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);",
"	else ",
"		qsendset(tmp->Queue, tmp->Qtype, tmp->sfield,tmp->vfield);",
"",
"	Result.atype = setAction.atype = tmp->atype;",
"	Result.Queue = setAction.Queue = tmp-> Queue;",
"	Result.nr_fields = setAction.nr_fields = tmp->nr_fields;",
"	for(i=0;i<Mpars;i++) {",
"		setAction.vfield[i] = fldval[i+2];",
"		setAction.sfield[i] = solid;",
"	}",
"	Result.sfield = setAction.sfield;",
"	Result.vfield = setAction.vfield;",
"#if 0",
"	fprintf(stderr, \"execute action [%%d]: %%-25s\\t( \",actionnr,tmp->string);",
"		fprintf(stderr, \"%%d\",fldval[2]);",
"		for(i=2;i<=abs(fldval[0]);i++) fprintf(stderr, \", %%d\",fldval[i+1]);",
"		fprintf(stderr, \" )\\n\"); ",
"#endif",
"	return Result;",
"}",
"",
"",
"ActionT",
"GetAction(int actionnr)",
"{	ActionT	 Result;",
"	IActionT *tmp;",
"	int i;",
"",
"	for (tmp=aroot; tmp->aident!=(short) actionnr;tmp=tmp->nxt);",
"	Result.atype = tmp->atype;",
"	Result.Queue = tmp-> Queue;",
"	Result.nr_fields = tmp->nr_fields;",
"	Result.sfield = tmp->sfield;",
"	Result.vfield = tmp->vfield;",
"",
"	return Result;",
"}",
"/***** trojka: trojka.c *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka interface							*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"/* version 1.7.4:	Thu Mar  4 14:54:07 MET 1999			*/",
"/* version 1.8.0:	Tue Jun 22 17:40:03 MET DST 1999		*/",
"/* version 1.9.0:	Fri Jan 28 18:40:09 CET 2000			*/",
"/* removed DriverVersion; handling of version is done at top; version.h */",
"/*----------------------------------------------------------------------*/",
"",
"#include <stdarg.h>",
"#include <stdio.h>",
"#include <time.h>",
"",
"#ifdef TANSTATIC",
"#include \"trojka.h\"",
"#include \"tan-sman.h\"",
"#include \"tan-action.h\"",
"#endif",
"",
"/*",
" * globals: lf = logfile",
"*/",
"",
"FILE	*lf, *sf, *efd;",
"",
"static char *title[] = {",
"	\"\\n\\n\",",
"	\"\\t***     \"",
"	DriverVersion",
"	\"      ***\",",
"	\"\\t***  Written by Rene G. de Vries based on SPIN-code by    *** \",",
"	\"\\t***       Gerard J. Holzmann (AT&T Corporation)           *** \",",
"	\"\\n\\n\",",
"	0",
"",
"	};",
"",
"StateSetT *SSvector = NULL;",
"uchar delta;",
"",
"/* === Internal procedures and functions === */",
"void",
"PrtStr (FILE *out, char* c[])",
"{",
"	int i;",
"        for (i = 0; c[i]; i++)",
"        {       fprintf(out, c[i]);",
"                fprintf(out, \"\\n\");",
"        }",
"}",
"",
"",
"/* === Exported functions and procedures === */",
"",
"Trojka_statT",
"getstats(void)",
"{",
"	Trojka_statT Result;",
"",
"	/* Global parameters */",
"	Result.nr_vector = createdstates;	/* tan-sman */",
"	Result.nr_svector = createdstructs;	/* tan-sman */",
"	Result.memcnt = memcnt;			/* tan.c */",
"",
"	/* Parameters after each trojka_engine command */",
"	Result.nr_cuts = cut;			/* tan-engine */",
"	Result.nr_analysed = analyse;		/* tan-engine */",
"	Result.nr_matched = matched;		/* tan-engine */",
"	Result.nr_supers =  SSnrel(&SSvector);",
"	Result.nr_executed = executed;		/* tan-engine */",
"	Result.depth = reacheddepth;		/* tan-engine */",
"	Result.delta = delta;",
"	Result.nr_actions = actionident;	/* tan-action */",
"",
"	return Result;",
"}",
"",
"void",
"Init_Trojka( Trojka_SettingsT Settings )       /* installs trojka_engine */",
"{",
"	Stack	*reset_stack;	/* knife to cutoff old context */",
"	Svtack	*reset_svtack;	/* knife to cutoff old context */",
"	",
"	Maxdiepte = Settings.maxdepth;",
"	if (Settings.maxdepth > maxdepth)",
"		maxdepth = Settings.maxdepth;",
"	ssize = Settings.ssize;",
"	mask = ((1<<ssize)-1);  /* hash init, to be used later on.*/",
"        Tinit();	/* initialize hashtable */",
"        trail = (Trail *) emalloc((maxdepth+2)*sizeof(Trail));",
"",
"	memset((char *)&now,0,sizeof(State));	/* clear state */",
"	vsize=sizeof(State)-VECTORSZ;",
"",
"	/* initialize stack to undo deletes of processes and queues */",
"	reset_stack = stack   = ( Stack *) emalloc(sizeof(Stack));",
"	/* initialize stack to save to undo-info receives from queues*/",
"        reset_svtack = svtack  = (Svtack *) emalloc(sizeof(Svtack)); ",
"	/* a place to point for Pptr of non-running procs: */",
"        noptr   = (uchar *) emalloc(Maxbody * sizeof(char));",
"",
"	settable();	/* init transition table */",
"	all_retrans();	/* optimize transitions table (required) */",
"",
"	iniglobals();",
"	UnBlock;	/* disable rendez-vous */",
"",
"	depth = 0;",
"	trpt = &trail[depth];	/* init the pointer trpt */",
"	",
"	active_procs();	/* set initial procs in state */",
"",
"	/* set rootstate in the superstatevecor */	",
"	nstates = 0; /* Just make sure */",
"",
"	IncludeState(&SSvector);	/* set root superstate */",
"	/* initial no atomic action TODO */",
"",
"	/* Passings settings to trojka-engine */",
"",
"	lf = Settings.logfile;",
"	sf = Settings.searchfile;",
"	HASH_NR = Settings.hashnumber;",
"	srandom(Settings.seed);",
"	",
"	PrtStr(stderr, title);",
"",
"	if (lf && lf != stderr) PrtStr(lf, title);",
"",
"",
"}	",
"",
"void",
"Analyse(void)",
"{",
"	ClearAction();	/* new search for actions */",
"	do_with_spec(&SSvector,ADD, &delta);		",
"} ",
"",
"",
"void",
"ExecDelta()",
"{	ClearAction();",
"	do_with_spec(&SSvector, DMOVE,  &delta);",
"}",
"   ",
"ActionT",
"ExecMove(int move)",
"{	ActionT Action;	",
"        Action = SetAction(move);",
"	ClearAction();",
"        do_with_spec(&SSvector,AMOVE, &delta);",
"	return Action;",
"}",
"",
"void  logprintf(char *format, ...)",
"{",
"   int sock, len, x;",
"   char* tijd;",
"   va_list args;",
"",
"   time_t tijd_t;",
"   tijd_t=time(NULL);",
"   tijd=ctime(&tijd_t);",
"   tijd[strlen(tijd)-1]=(char) 0;",
"  ",
"   va_start(args, format);",
"   if (lf) {fprintf(lf,\"[%%s] \",tijd); vfprintf(lf, format, args);}",
"   va_end(args);",
"}",
"",
"",
"",
0
};

static char *engineh[]  = { /* trojka engine headers */
"/***** trojka: tan-sman.h *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka analyser state manager					*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"",
"#ifndef H_TAN_SMAN",
"#define H_TAN_SMAN",
"",
"#ifndef uchar",
"#define uchar	unsigned char",
"#endif",
"",
"#if 0",
"",
"/* === declare extern globals from tan.c (executed in tan-sman.c) === */",
"extern	int	j1;		/* hash value (result of s_hash) */",
"extern	int	ssize;		/* 2^ssize hash table entries */",
"extern	int	mask;		/* 2^ssize - 1 */",
"extern	int	truncs;		/* match counter */",
"extern	int	hcmp;		/* hash conficts counter */	",
"",
"/* === declare extern procedures/functions from tan.c === */",
"void	s_hash(uchar*, int);	/* hash function */",
"char	*emalloc(unsigned);	/* never released or reallocated memory proc */",
"",
"#endif",
"",
"/* === declaration of datatypes === */",
"",
"typedef struct StateStrT {		/* datatype to store state structure */",
"	unsigned short	nr_users;		/* #user using this item */",
"	int 		proc_struct[MAXPROC];	/* copy of pan's proc_offset */",
"	int		q_struct[MAXQ];		/* copy of pan's q_offset */",
"	struct StateStrT *nxt;			/* double-linked list */",
"	struct StateStrT *last;		",
"} StateStrT;",
"",
"typedef struct StateSetT{	/* datatype to store a states */",
"	short firstproc;		/* parameter for atomic move */",
"	short lastproc;			/* parameter for atomic move  */",
"        int vsize;      		/* length of the selected state */",
"        char *body;     		/* pointer to a stored state */",
"        uchar delta;    		/* room for output-suspension info */",
"	struct StateStrT *struc;	/* pointer to structure	of the state */",
"        struct StateSetT *nxt;	",
"} StateSetT;",
"",
"/* === prototypes and exported functions/procedures === */",
"",
"void",
"SSaddstate(	StateSetT**,	/* A		(io) */ ",
"	 	State*,		/* state	(in) */",
"	 	int,		/* size		(in) */",
"		char*,		/* proc_offset	(in) */",
"		char*,		/* q_offset	(in) */",
"		uchar		/* delta	(in) */",
"	);",
"/* includes state with parameters size, proc_offset, q_offset and delta in A */",
"",
"",
"void",
"SSclear (",
"	StateSetT**			/* A (io) */",
"	);",
"/* empties the stateset A*/",
"",
"",
"void",
"SSmerge	(",
"	StateSetT**,			/* A (io) */",
"	StateSetT**			/* B (io) */",
"	);",
"/* includes stateset B in A and empties set B */",
"",
"int",
"SSnrel (",
"	StateSetT**			/* A (in) */",
"	);",
"/* return the number of elements in stateset A */ ",
"",
"void",
"Tinit(void);",
"/* initialize the hash table */",
"",
"",
"void ",
"Trelease();",
"/* reinstall the hash table (clears all entries) */",
"",
"void",
"Tstore(	State*		/* in: state */, ",
"	int,		/* in: size of statevector */",
"	int*,		/* in: p_offset */",
"	int*,		/* in: q_offset */",
"	uchar);		/* in: delta */",
"/* stores the statevector with parameters into hash-table */",
"",
"",
"int",
"Thit(	State*		/* in: state */, ",
"	int,		/* in: size of statevector */",
"	int*,		/* in: p_offset */",
"	int*,		/* in: q_offset */",
"	uchar*);	/* out: delta */",
"/* checks if statevector with parameters is already a member of hash_table */",
"/* returns 0 if not so, unequal to 0 otherwise */",
"/* if already a member: delta gets stored value */",
"",
"void   ",
"IncludeState(StateSetT** /* inout: Set */);",
"/* saves state and context in Set  */",
"",
"void",
"ResState(StateSetT* /* in: State */);",
"/* restores state State in now ect. */",
"",
"",
"",
"",
"#endif",
"/***** trojka: tan-engine.h *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka analyser engine						*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"/*----------------------------------------------------------------------*/",
"",
"",
"#ifndef H_TANENGINE",
"#define H_TANENGINE",
"",
"#ifdef TANSTATIC",
"#include \"tan-sman.h\"",
"#endif",
"",
"/* actions for transact (tan.r) and do_with_spec (tan-engine) */",
"#define SET     1",
"#define MOVE    2",
"#define OBS     3",
"#define DMOVE   4",
"#define AMOVE   5",
"#define ADD     6",
"",
"/* serveral tags for actions */",
"#define TAU     0",
"#define INPUT   1",
"#define OUTPUT  2",
"#define BLOCKED 3",
"",
"",
"#ifndef uchar",
"#define uchar   unsigned char",
"#endif",
"",
"/* declaration of depth when a branch is cut */",
"int Maxdiepte	= 0;	/* default; 0 means infinite */",
"",
"/* declaration of global vars used by tan.[chr] */",
"int observable;",
"",
"/* declaration of global status-variables */",
"",
"int	cut;		/* number of cut branches after engine-call */",
"int	reacheddepth;	/* maximum reached depth after engine-call */",
"int	executed;	/* number of executed io-actions after engine-call */",
"int	matched;	/* number of matched states after engine-call */",
"int	analyse;	/* number of analysed states after engine-call */",
"",
"",
"/* prototypes */",
"		",
"void",
"do_with_spec(	StateSetT**,	/*inout: superstate */",
"		uchar,		/*in: command */	",
"		uchar*		/*out: deltasuspension */",
"		);",
"",
"#endif",
"/***** trojka: tan-action.h *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka analyser action handler					*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"/*----------------------------------------------------------------------*/",
"",
"#ifndef H_TAN_ACTION",
"#define H_TAN_ACTION",
"",
"#ifdef TANSTATIC",
"#include \"trojka.h\"",
"#endif",
"",
"#if 0",
"	external usage of global variables from pan.c:",
"	G_Qtype, G_Sfields, G_Vfields, Mpars",
"#endif",
"",
"#ifndef uchar",
"#define uchar   unsigned char",
"#endif",
"",
"/* exported datatypes */",
"typedef struct IActionT {	/* datatype to store an internal action */ ",
"",
"	short		aident;		/* action identifier */",
"	AtypeT		atype;		/* actiontype	*/",
"	uchar		Queue;		/* queue number */",
"	uchar		Qtype;		/* queue type */",
"	char		*string;	/* ascii action string */",
"	short		nr_fields;	/* nr of field */",
"	fieldT		sfield[Mpars];	/* field settting tag */",
"	int		vfield[Mpars];	/* field value  */",
"	struct IActionT	*nxt;		/* linked list */",
"",
"} IActionT;",
"",
"",
"",
"void",
"Addaction(uchar /*in*/, AtypeT /*in*/, char* /*in*/);",
"/* add current selected action (G_vars) and parameters to actionlist */",
"",
"",
"void",
"ClearAction(void);",
"/* remove all actions from the current actionlist */",
"				",
"void",
"PrtAction(FILE* , int /* actionnr */);",
"/* print action actionnr in text to output file out */",
"",
"",
"ActionT",
"SetAction(int /* actionnr */);",
"/* set trojka-engine to action actionnr (with parameter generation) */",
"/* return an action with the valid parameters */",
"",
"",
"ActionT",
"GetAction(int);",
"/* return action identified by the parameter */",
"",
"#endif",
0
};

static char *trojkah[]  = { /* trojka module header */
"/***** trojka: trojka.h *****/",
"",
"/* Copyright (c) 1991,1995 by AT&T Corporation.  All Rights Reserved.     */",
"/* This software is for educational purposes only.                        */",
"/* Permission is given to distribute this code provided that this intro-  */",
"/* ductory message is not removed and no monies are exchanged.            */",
"/* No guarantee is expressed or implied by the distribution of this code. */",
"/* Software written by Gerard J. Holzmann as part of the book:            */",
"/* `Design and Validation of Computer Protocols,' ISBN 0-13-539925-4,     */",
"/* Prentice Hall, Englewood Cliffs, NJ, 07632.                            */",
"/* Send bug-reports and/or questions to: gerard@research.att.com          */",
"",
"/*	Modified code and additional routines for the trojka analyser	*/",
"/*	No guarantee is expressed or implied!				*/",
"/*									*/",
"/* No permission is given to distribute the modified code and		*/",
"/* additional routines without permission of the author.		*/",
"/*									*/",
"/* Modified code and additional routines written by Rene G. de Vries	*/",
"/*									*/",
"/* trojka interface							*/",
"/* version 1.0 :	Tue Jun 11 20:32:02 MET DST 1996		*/",
"",
"#ifndef H_TROJKA",
"#define H_TROJKA",
"",
"#include <stdio.h>",
"",
"/* exported datatypes */",
"",
"typedef	enum	{ input, output } AtypeT;",
"typedef enum	{ variable, solid } fieldT;",
"",
"typedef struct ActionT{	/* datatype to store an action */ ",
"",
"	AtypeT	atype;		/* actiontype	*/",
"	short	Queue;		/* queue number */",
"	short	nr_fields;	/* nr of field */",
"	fieldT	*sfield;	/* field settting tag (array[1..nr_fields] ) */",
"	int	*vfield;	/* field value (array[1..nr_fields]) */",
"	",
"} ActionT;",
"",
"typedef struct Trojka_SettingsT {	/* datatype to pass Trojka settings */",
"",
"	FILE	*logfile;	/* file to store log-info */",
"	FILE	*searchfile;	/* file to store search-traces */",
"	int	hashnumber;	/* hash number to be used (see spin) */",
"	int	maxdepth;	/* maxium depth until cut is preformed */",
"	int	ssize;		/* hashtable statespace size: 2^ssize */  ",
"	int	seed;		/* seed value for the random generator */",
"",
"} Trojka_SettingsT;",
"",
"typedef struct	Trojka_statT {		/* datatype to store statistics */",
"",
"	/* Global parameters */",
"	int	nr_vector;	/* number of created statevectors */",
"	int	nr_svector;	/* number of created structures for vectors */",
"	double	memcnt;		/* memory usage counter */",
"",
"	/* Parameters after each trojka_engine command */",
"	int	nr_cuts;	/* number of cut branches */",
"	int	nr_analysed;	/* number of actual analysed states */",
"	int	nr_matched;	/* number of matched states */",
"	int	nr_supers;	/* number of elements of superstate vector */",
"	int	nr_executed;	/* number of executed actions */",
"	int	depth;		/* maximum reached depth of branchs */",
"	char	delta;		/* current superstate has delta suspension */",
"	short	nr_actions;	/* number of possible actions */",
"",
"} Trojka_statT;",
"",
"/* exported procedures and functions */",
"",
"void",
"Init_Trojka( Trojka_SettingsT /* in */ );	/* installs trojka_engine */",
"",
"Trojka_statT",
"getstats(void);					/* return trojka statistics */",
"",
"void",
"Analyse(void);		/* analyses the current superstate */",
"",
"                               ",
"void",
"PrtAction(FILE* , int /* actionnr */);",
"/* print action actionnr in text to output file out */",
"",
"",
"ActionT",
"GetAction(int);",
"/* return action identified by the parameter */",
"",
"ActionT",
"SetAction(int);",
"/* instatntiate action identified by the parameter and return it */",
"",
"",
"void",
"ExecDelta();		/* pass an execute delta-move to the trojka-engine */",
"",
" ",
"ActionT",
"ExecMove(int /* move */);	/* execute action move */",
"",
"char*",
"Mval2Name(unsigned char /* mtype value */); /* give the symbolic name of a enumerated mtype */",
"",
"unsigned char",
"MName2Val(char* /* mtype symbolic name */); /* give the enumerate number identifier of the symbolic name of a mtype member*/",
"",
"char*",
"Qid2Name(int /* queue number */); /* give the symbolic name of queue cf. ActionT->Queue */",
"",
"char**",
"QidFieldTypes(int /* queue number */); /* give types of the queue elements */",
"",
"void",
"logprintf(char *, ...); /* print to the logfile logfile, used in setting printflike */",
"",
"#endif",
0
};

