#!/bin/sh

prog=preprocmkprimer

if [ $# -lt 3 ]; then
	echo "usage: $prog preproc [preproc-args...] .newsuffix input-spec.suffix" 1>& 2
	exit 1
fi

preproc=$1
shift

while [ $# -gt 2 ]; do
  args="$args $1"
  shift
done

newext=$1
shift

file=$1
shift

if [ ! -r $file ]; then
	echo "$prog: cannot open(r) $file" 1>& 2
	exit 1
fi

base=`echo $file | sed 's/\.[^.]*$//' `
if [ "X$file" = "X$base" ]; then
	echo "$prog: .suffix missing for input-spec filename: $base" 1>& 2
	exit 1
fi

curdirbase=`echo $base | sed 's/.*\///g' `
newfile=$curdirbase$newext

$preproc $args $file > $newfile
mkprimer $newfile
