#! /bin/sh

ROOT=@prefix@
TKGNATSLIB=@tkgnatslibdir@
export TKGNATSLIB
WISH=@WISH@

default_tkgnats_subdir=Src/third_party/tkgnats

# default_anyfile: any recognizable source file
default_anyfile=torx-querypr.sh

# when we need a basename, we first compute the dirname because that is
# relatively easy to do, using sed, and then we compute the basename by
# subtracting the found dirname from the name we started with.
# (not all systems have dirname or basename programs)

scriptname=$0
script_dirname=`echo $scriptname | sed "s%/*[^\/][^\/]*$%%" `
script_basename=`echo $scriptname | sed "s%$script_dirname//*%%" `

if test X"$TORX_ROOT" != "X" ; then
	TKGNATSLIB=`echo $TKGNATSLIB | sed "s/$ROOT/$TORX_ROOT/" `
elif test ! -d $TKGNATSLIB ; then
	# maybe we have started the script from the distribution dir
	# instead of the installation dir; try to find distr (cur) dir
	script_root=`echo $script_dirname | sed "s%$default_tkgnats_subdir%%" `
	lib_dirname=`echo $TKGNATSLIB | sed "s%/*[^\/][^\/]*$%%" `
	lib_basename=`echo $TKGNATSLIB | sed "s%$lib_dirname//*%%" `
	if test "X$script_root" != "X" ; then
		program_root=$script_root
		TKGNATSLIB="$script_root/$lib_basename"
	elif test -r $default_anyfile ; then
		program_root=.
		TKGNATSLIB=`pwd`"/$lib_basename"
	else
		echo "$script_basename: Could not find the library files, please check installation" 2>&1
		exit
	fi
fi


$WISH $TKGNATSLIB/tksendpr.tcl -server '"@CAPITALIZEDPACKAGE@ Problems" @GNATS_SERVER@ @GNATS_PORT@ @GNATS_ADDR@ @GNATSServerDir@ @GNATSDatabaseAlias@' -release @VERSION@
